import { Injectable, ɵɵdefineInjectable, Directive, Renderer2, ElementRef, Input, HostListener, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { MatDialog } from '@angular/material/dialog';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgAppHelpService {
    constructor() {
        this.appHelpEnabledSubject = new BehaviorSubject(false);
        this.appHelpEnabled$ = this.appHelpEnabledSubject.asObservable();
    }
    /**
     * @param {?} enabled
     * @return {?}
     */
    setAppHelpEnabled(enabled) {
        this.appHelpEnabledSubject.next(enabled);
    }
    /**
     * @return {?}
     */
    getAppHelpEnabled() {
        return this.appHelpEnabledSubject.getValue();
    }
}
NgAppHelpService.decorators = [
    { type: Injectable, args: [{
                providedIn: 'root'
            },] }
];
/** @nocollapse */
NgAppHelpService.ctorParameters = () => [];
/** @nocollapse */ NgAppHelpService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgAppHelpService_Factory() { return new NgAppHelpService(); }, token: NgAppHelpService, providedIn: "root" });
if (false) {
    /**
     * @type {?}
     * @private
     */
    NgAppHelpService.prototype.appHelpEnabledSubject;
    /** @type {?} */
    NgAppHelpService.prototype.appHelpEnabled$;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help-enabled.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgAppHelpEnabledDirective {
    /**
     * @param {?} appHelpSvc
     * @param {?} dialog
     * @param {?} renderer
     * @param {?} elementRef
     */
    constructor(appHelpSvc, dialog, renderer, elementRef) {
        this.appHelpSvc = appHelpSvc;
        this.dialog = dialog;
        this.renderer = renderer;
        this.elementRef = elementRef;
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.sub = this.appHelpSvc.appHelpEnabled$.subscribe((/**
         * @param {?} enabled
         * @return {?}
         */
        (enabled) => {
            if (enabled) {
                this.renderer.addClass(this.elementRef.nativeElement, this.highlightClass);
            }
            else {
                this.renderer.removeClass(this.elementRef.nativeElement, this.highlightClass);
            }
        }));
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.sub.unsubscribe();
    }
    /**
     * @return {?}
     */
    onMouseOver() {
        if (this.appHelpSvc.getAppHelpEnabled()) {
            this.timer = setInterval((/**
             * @return {?}
             */
            () => {
                /** @type {?} */
                const dialogRef = this.dialog.open(this.helpTemplate);
                clearInterval(this.timer);
            }), 500);
        }
    }
    /**
     * @return {?}
     */
    onMouseOut() {
        if (this.timer) {
            clearInterval(this.timer);
        }
    }
}
NgAppHelpEnabledDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngAppHelpEnabled]'
            },] }
];
/** @nocollapse */
NgAppHelpEnabledDirective.ctorParameters = () => [
    { type: NgAppHelpService },
    { type: MatDialog },
    { type: Renderer2 },
    { type: ElementRef }
];
NgAppHelpEnabledDirective.propDecorators = {
    highlightClass: [{ type: Input, args: ['highlightClass',] }],
    helpTemplate: [{ type: Input, args: ['helpTemplate',] }],
    onMouseOver: [{ type: HostListener, args: ['mouseover',] }],
    onMouseOut: [{ type: HostListener, args: ['mouseout',] }]
};
if (false) {
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.highlightClass;
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.helpTemplate;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.sub;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.timer;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.appHelpSvc;
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.dialog;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help-enabler-button.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgAppHelpEnablerButtonDirective {
    /**
     * @param {?} appHelpSvc
     * @param {?} dialog
     */
    constructor(appHelpSvc, dialog) {
        this.appHelpSvc = appHelpSvc;
        this.dialog = dialog;
    }
    /**
     * @return {?}
     */
    onClick() {
        this.showFirstTimeHelpIfSpecified();
        this.appHelpSvc.setAppHelpEnabled(!this.appHelpSvc.getAppHelpEnabled());
    }
    /**
     * @private
     * @return {?}
     */
    showFirstTimeHelpIfSpecified() {
        /** @type {?} */
        const hasSeenFirstTimeHelp = localStorage.getItem('hasShownFirstTimeHelp');
        if (!hasSeenFirstTimeHelp) {
            this.openFirstTimeTemplate();
        }
    }
    /**
     * @return {?}
     */
    onDoubleClick() {
        this.openFirstTimeTemplate();
    }
    /**
     * @private
     * @return {?}
     */
    openFirstTimeTemplate() {
        if (this.helpTemplate) {
            /** @type {?} */
            const dialogRef = this.dialog.open(this.helpTemplate);
            localStorage.setItem('hasShownFirstTimeHelp', "true");
        }
    }
}
NgAppHelpEnablerButtonDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngAppHelpEnablerButton]'
            },] }
];
/** @nocollapse */
NgAppHelpEnablerButtonDirective.ctorParameters = () => [
    { type: NgAppHelpService },
    { type: MatDialog }
];
NgAppHelpEnablerButtonDirective.propDecorators = {
    helpTemplate: [{ type: Input, args: ['helpTemplate',] }],
    onClick: [{ type: HostListener, args: ['click',] }],
    onDoubleClick: [{ type: HostListener, args: ['dblclick',] }]
};
if (false) {
    /** @type {?} */
    NgAppHelpEnablerButtonDirective.prototype.helpTemplate;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnablerButtonDirective.prototype.appHelpSvc;
    /** @type {?} */
    NgAppHelpEnablerButtonDirective.prototype.dialog;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgAppHelpModule {
}
NgAppHelpModule.decorators = [
    { type: NgModule, args: [{
                declarations: [NgAppHelpEnabledDirective, NgAppHelpEnablerButtonDirective],
                imports: [],
                exports: [NgAppHelpEnablerButtonDirective, NgAppHelpEnabledDirective]
            },] }
];

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: plummer-libs-ng-app-help.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgAppHelpEnabledDirective, NgAppHelpEnablerButtonDirective, NgAppHelpModule, NgAppHelpService };
//# sourceMappingURL=plummer-libs-ng-app-help.js.map
