import { Injectable, ɵɵdefineInjectable, Directive, Renderer2, ElementRef, Input, HostListener, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs';
import { MatDialog } from '@angular/material/dialog';

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help.service.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgAppHelpService = /** @class */ (function () {
    function NgAppHelpService() {
        this.appHelpEnabledSubject = new BehaviorSubject(false);
        this.appHelpEnabled$ = this.appHelpEnabledSubject.asObservable();
    }
    /**
     * @param {?} enabled
     * @return {?}
     */
    NgAppHelpService.prototype.setAppHelpEnabled = /**
     * @param {?} enabled
     * @return {?}
     */
    function (enabled) {
        this.appHelpEnabledSubject.next(enabled);
    };
    /**
     * @return {?}
     */
    NgAppHelpService.prototype.getAppHelpEnabled = /**
     * @return {?}
     */
    function () {
        return this.appHelpEnabledSubject.getValue();
    };
    NgAppHelpService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgAppHelpService.ctorParameters = function () { return []; };
    /** @nocollapse */ NgAppHelpService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgAppHelpService_Factory() { return new NgAppHelpService(); }, token: NgAppHelpService, providedIn: "root" });
    return NgAppHelpService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NgAppHelpService.prototype.appHelpEnabledSubject;
    /** @type {?} */
    NgAppHelpService.prototype.appHelpEnabled$;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help-enabled.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgAppHelpEnabledDirective = /** @class */ (function () {
    function NgAppHelpEnabledDirective(appHelpSvc, dialog, renderer, elementRef) {
        this.appHelpSvc = appHelpSvc;
        this.dialog = dialog;
        this.renderer = renderer;
        this.elementRef = elementRef;
    }
    /**
     * @return {?}
     */
    NgAppHelpEnabledDirective.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.sub = this.appHelpSvc.appHelpEnabled$.subscribe((/**
         * @param {?} enabled
         * @return {?}
         */
        function (enabled) {
            if (enabled) {
                _this.renderer.addClass(_this.elementRef.nativeElement, _this.highlightClass);
            }
            else {
                _this.renderer.removeClass(_this.elementRef.nativeElement, _this.highlightClass);
            }
        }));
    };
    /**
     * @return {?}
     */
    NgAppHelpEnabledDirective.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.sub.unsubscribe();
    };
    /**
     * @return {?}
     */
    NgAppHelpEnabledDirective.prototype.onMouseOver = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.appHelpSvc.getAppHelpEnabled()) {
            this.timer = setInterval((/**
             * @return {?}
             */
            function () {
                /** @type {?} */
                var dialogRef = _this.dialog.open(_this.helpTemplate);
                clearInterval(_this.timer);
            }), 500);
        }
    };
    /**
     * @return {?}
     */
    NgAppHelpEnabledDirective.prototype.onMouseOut = /**
     * @return {?}
     */
    function () {
        if (this.timer) {
            clearInterval(this.timer);
        }
    };
    NgAppHelpEnabledDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngAppHelpEnabled]'
                },] }
    ];
    /** @nocollapse */
    NgAppHelpEnabledDirective.ctorParameters = function () { return [
        { type: NgAppHelpService },
        { type: MatDialog },
        { type: Renderer2 },
        { type: ElementRef }
    ]; };
    NgAppHelpEnabledDirective.propDecorators = {
        highlightClass: [{ type: Input, args: ['highlightClass',] }],
        helpTemplate: [{ type: Input, args: ['helpTemplate',] }],
        onMouseOver: [{ type: HostListener, args: ['mouseover',] }],
        onMouseOut: [{ type: HostListener, args: ['mouseout',] }]
    };
    return NgAppHelpEnabledDirective;
}());
if (false) {
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.highlightClass;
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.helpTemplate;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.sub;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.timer;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.appHelpSvc;
    /** @type {?} */
    NgAppHelpEnabledDirective.prototype.dialog;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.renderer;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnabledDirective.prototype.elementRef;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help-enabler-button.directive.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgAppHelpEnablerButtonDirective = /** @class */ (function () {
    function NgAppHelpEnablerButtonDirective(appHelpSvc, dialog) {
        this.appHelpSvc = appHelpSvc;
        this.dialog = dialog;
    }
    /**
     * @return {?}
     */
    NgAppHelpEnablerButtonDirective.prototype.onClick = /**
     * @return {?}
     */
    function () {
        this.showFirstTimeHelpIfSpecified();
        this.appHelpSvc.setAppHelpEnabled(!this.appHelpSvc.getAppHelpEnabled());
    };
    /**
     * @private
     * @return {?}
     */
    NgAppHelpEnablerButtonDirective.prototype.showFirstTimeHelpIfSpecified = /**
     * @private
     * @return {?}
     */
    function () {
        /** @type {?} */
        var hasSeenFirstTimeHelp = localStorage.getItem('hasShownFirstTimeHelp');
        if (!hasSeenFirstTimeHelp) {
            this.openFirstTimeTemplate();
        }
    };
    /**
     * @return {?}
     */
    NgAppHelpEnablerButtonDirective.prototype.onDoubleClick = /**
     * @return {?}
     */
    function () {
        this.openFirstTimeTemplate();
    };
    /**
     * @private
     * @return {?}
     */
    NgAppHelpEnablerButtonDirective.prototype.openFirstTimeTemplate = /**
     * @private
     * @return {?}
     */
    function () {
        if (this.helpTemplate) {
            /** @type {?} */
            var dialogRef = this.dialog.open(this.helpTemplate);
            localStorage.setItem('hasShownFirstTimeHelp', "true");
        }
    };
    NgAppHelpEnablerButtonDirective.decorators = [
        { type: Directive, args: [{
                    selector: '[ngAppHelpEnablerButton]'
                },] }
    ];
    /** @nocollapse */
    NgAppHelpEnablerButtonDirective.ctorParameters = function () { return [
        { type: NgAppHelpService },
        { type: MatDialog }
    ]; };
    NgAppHelpEnablerButtonDirective.propDecorators = {
        helpTemplate: [{ type: Input, args: ['helpTemplate',] }],
        onClick: [{ type: HostListener, args: ['click',] }],
        onDoubleClick: [{ type: HostListener, args: ['dblclick',] }]
    };
    return NgAppHelpEnablerButtonDirective;
}());
if (false) {
    /** @type {?} */
    NgAppHelpEnablerButtonDirective.prototype.helpTemplate;
    /**
     * @type {?}
     * @private
     */
    NgAppHelpEnablerButtonDirective.prototype.appHelpSvc;
    /** @type {?} */
    NgAppHelpEnablerButtonDirective.prototype.dialog;
}

/**
 * @fileoverview added by tsickle
 * Generated from: lib/ng-app-help.module.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgAppHelpModule = /** @class */ (function () {
    function NgAppHelpModule() {
    }
    NgAppHelpModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgAppHelpEnabledDirective, NgAppHelpEnablerButtonDirective],
                    imports: [],
                    exports: [NgAppHelpEnablerButtonDirective, NgAppHelpEnabledDirective]
                },] }
    ];
    return NgAppHelpModule;
}());

/**
 * @fileoverview added by tsickle
 * Generated from: public-api.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * Generated from: plummer-libs-ng-app-help.ts
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgAppHelpEnabledDirective, NgAppHelpEnablerButtonDirective, NgAppHelpModule, NgAppHelpService };
//# sourceMappingURL=plummer-libs-ng-app-help.js.map
